#include <stdlib.h>
#include <string.h>

#include "bitmap.h"

/* vytvo obrzek */
BITMAP *createbitmap2(unsigned long int sizex, unsigned long int sizey,
  unsigned long int bitdepth, long int alignment)
{
  BITMAP *bitmap;
  int i;

  /* obrzek nulov velikosti nechceme, vc jak 32 bit taky ne */
  if (sizex * sizey * ((bitdepth + 7) >> 3) == 0 || bitdepth > 32)
    return NULL;
  
  /* vytvo strukturu pro obrzek vetn msta pro seznam dk */
  if ((bitmap = (BITMAP *) malloc(sizeof(BITMAP)
    + (sizey - 1) * sizeof(void *))) == NULL) return NULL;

  bitmap->width  = sizex;
  bitmap->height = sizey;
  bitmap->bits   = bitdepth;
  bitmap->bytes  = (bitdepth + 7) >> 3;
  bitmap->bwidth = bitmap->width * bitmap->bytes;
  bitmap->size   = bitmap->height * bitmap->bwidth;
  
  /* nechceme unsigned long long int :( */
  bitmap->bitmask  = (((1 << (bitdepth - 1)) - 1) << 1) | 1;
  bitmap->bitumask = ~bitmap->bitmask;

  if (alignment >= 2) /* zarovnme velikost obrzku */
    bitmap->size = (bitmap->size + alignment - 1) & (~(alignment - 1));

  /* alokujeme pam */
  if ((bitmap->handle = malloc(bitmap->size)) == NULL)
  {
    free(bitmap);
    return NULL;
  }

  /* smaeme pam */
  memset(bitmap->handle, 0, bitmap->size);

  for (i = 0; i < bitmap->height; i++)
    bitmap->lines[i] = (void *) ((unsigned long int) bitmap->handle +
      (i * bitmap->bwidth));

  return bitmap;
}  

/* uvoln obrzek z pamti */
void freebitmap(BITMAP *bitmap) {
  if (bitmap != NULL) {
    if (bitmap->handle != NULL)
      free(bitmap->handle);
    free(bitmap);
  }
}
