#ifndef __bitmap_h
#define __bitmap_h

/* obrzkov struktura */

typedef struct {
  unsigned long int width;
  unsigned long int height;
  unsigned long int bits;
  unsigned long int bytes;
  unsigned long int bwidth;
  unsigned long int size;
  unsigned long int bitmask;
  unsigned long int bitumask;
  void *handle;
  void *lines[1];
} BITMAP;

#ifdef __cplusplus
extern "C" {
#endif

/* vytvo obrzek */
BITMAP *createbitmap2(unsigned long int sizex, unsigned long int sizey,
  unsigned long int bitdepth, long int alignment);

/* uvoln obrzek z pamti */
void freebitmap(BITMAP *bitmap);

/* funkce putpixel (inline) */
static void inline b_putpixel(BITMAP *bmp, unsigned int x, unsigned int y,
  unsigned long int c) {
  x *= bmp->bytes;
#if 0  
  /* takto je to podstatn lep, ale AISA m njakej divnej procesor :( */
  /* uvolnme msto pro nov pixel */
  * (unsigned long int *) ((unsigned long int) bmp->lines[y] + x) &=
    bmp->bitumask;
  /* zapeme jej */
  * (unsigned long int *) ((unsigned long int) bmp->lines[y] + x) |=
    c & bmp->bitmask;
#endif
  unsigned char *p = (unsigned char *) ((unsigned long int) bmp->lines[y] + x);
  unsigned long int bm = bmp->bitmask;
  for (c &= bm; bm != 0; c >>= 8, bm >>= 8)
    *p++ = c & 0xff;
}

/* funkce getpixel (inline) */
static unsigned long int inline b_getpixel(BITMAP *bmp, unsigned int x,
  unsigned int y) {
  unsigned char *p = (unsigned char *) ((unsigned long int) bmp->lines[y] + x);
  return (p[0] | (p[1] << 8) | (p[2] << 16) | (p[3] << 24)) & bmp->bitmask;
}

#ifdef __cplusplus
}
#endif

#endif /* __bitmap_h */
