#include "texture.h"

GLuint createtexturefrombitmap2(BITMAP *bitmap, GLint minfilter,
  GLint magfilter) {

  GLuint textureid;
  
  /* create new texture */
  glGenTextures(1, &textureid);
  glBindTexture(GL_TEXTURE_2D, textureid);
  /* convert image to texture */
  glTexImage2D(GL_TEXTURE_2D, 0, 3, bitmap->width, bitmap->height, 0,
    GL_RGB, GL_UNSIGNED_BYTE, bitmap->handle);
  /* filtering settings */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minfilter);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, magfilter);      
  
  return textureid;
}

GLuint createtexturefrombitmap(BITMAP *bitmap) {
  return createtexturefrombitmap2(bitmap, GL_LINEAR, GL_LINEAR);
}
