#include <malloc.h>
#include <string.h>

#include "stack.h"

#if 0
/*
 *  Datovy typ zasobniku
 */
typedef struct xy {
    int x, y;
} XY;

/*
 *  Polozka zasobniku
 */
typedef struct item {
    XY value;
    struct item *next;
} ITEM;

typedef ITEM *STACK;
#endif

/*
 *  Inicializuje zasobnik: vzdy provest na zacatku.
 */
int stack_init(STACK *stack) {
  if (stack == NULL) return -1;
  *stack = NULL;
  return 0; /* mj zpsob je jin */
}

static int stack_init_2(STACK *stack) {
  if (stack == NULL) return -1;
  if ((*stack = (ITEM *) malloc(sizeof(ITEM))) == NULL) return -2;
  (*stack)->next = NULL;
  return 0;
}

/*
 *  Ulozi hodnotu na vrchol zasobniku.
 */
int stack_push(STACK *stack, XY value) {
  if (stack == NULL) return -1;
  STACK oldstack = *stack;
  int stat;
  if ((stat = stack_init_2(stack)) != 0) return stat;
  (*stack)->value = value;
  (*stack)->next = oldstack;
  return 0;
}

/*
 *  Vybere ze zasobniku hodnotu na vrcholu.
 */
int stack_pop(STACK *stack, XY *value) {
  if (stack == NULL || *stack == NULL) return -1;  
  STACK oldstack = *stack;
  if (value != NULL) *value = oldstack->value;
  *stack = oldstack->next;
  free(oldstack);
  return 0;
}

/*
 *  Vymaze zasobnik.
 */
int stack_clear(STACK *stack) {
  if (stack == NULL || *stack == NULL) return -1;
  while (stack_pop(stack, NULL) == 0);
  return 0;
}

/*
 *  Vraci 1, kdyz je zasobnik prazdny, 0, kdyz neprazdny.
 */
int stack_empty(STACK stack) {
  return stack == NULL;
}
