#ifndef _STACK_H
#define _STACK_H

/*
 *  Datovy typ zasobniku
 */
typedef struct xy {
    int x, y;
} XY;

/*
 *  Polozka zasobniku
 */
typedef struct item {
    XY value;
    struct item *next;
} ITEM;

typedef ITEM *STACK;

/*
 *  Inicializuje zasobnik: vzdy provest na zacatku.
 */
int stack_init(STACK *stack);

/*
 *  Ulozi hodnotu na vrchol zasobniku.
 */
int stack_push(STACK *stack, XY value);

/*
 *  Vybere ze zasobniku hodnotu na vrcholu.
 */
int stack_pop(STACK *stack, XY *value);

/*
 *  Vymaze zasobnik.
 */
int stack_clear(STACK *stack);

/*
 *  Vraci 1, kdyz je zasobnik prazdny, 0, kdyz neprazdny.
 */
int stack_empty(STACK stack);

#endif
