#include "bitmap_libart.h"

/* pevod vektorov struktury na obrzek */
int bitmap_artsvp_render_path(BITMAP *bmp, const ArtSVP *path,
  unsigned long int color)
{
  if (bmp == NULL)
    return RP_NO_BITMAP;

  /* namrme to, co je popsno ve struktue ArtSVP */
  art_rgb_svp_alpha(path, 0, 0, bmp->width, bmp->height, 
    color, bmp->handle, bmp->bwidth, NULL);

  return RP_OK;
}

/* vytvoen vektorovho popisu krunice */
ArtSVP *artsvp_circle(unsigned int x, unsigned int y, unsigned int r,
  int filled) {
  ArtVpath *v;
  ArtSVP *c;
  /* nachystme krunici */
  if ((v = art_vpath_new_circle(x, y, r)) == NULL)
    return NULL;
  /* pevedeme na nco, co se u d nakreslit */
  if (filled)
    c = art_svp_from_vpath(v);
  else
    c = art_svp_vpath_stroke(v, ART_PATH_STROKE_JOIN_ROUND,
      ART_PATH_STROKE_CAP_ROUND, 1.0, 1.0, 1.0);
  art_free(v);
  return c;
}

/* pevod vektorovho popisu krunice na rastrov obrzek */
int bitmap_circle_artsvp(BITMAP *bmp, unsigned int x, unsigned int y,
  unsigned int r, int filled, unsigned long int color) {
  int state;
  ArtSVP *c = artsvp_circle(x, y, r, filled);
  if (c == NULL) return BM_CIRCLE_FAILED;
  state = bitmap_artsvp_render_path(bmp, c, (color & 0xffffff) << 8 | 0xff);
  art_free(c);
  return state < 0 ? BM_CIRCLE_FAILED : BM_CIRCLE_OK;
}
