#include <stdio.h>
#include <ctype.h>
#include "bitmap_write.h"

/* souhrn metod pro zpis */
#define BITMAP_WRITE_METHODS_COUNT 3
static struct bitmap_write_methods {
  int (*method)(const BITMAP *, FILE *);
  char *id;
  int type;
} bitmap_write_methods[] = {
  /* bn ppony sem */
  { bitmap_write_png, "png", 0 },
  { bitmap_write_jpeg, "jpg", 1 },
  /* divn ppony pro zmnu sem */
  { bitmap_write_jpeg, "jpeg", 1 },
  { NULL, NULL, -1 } };
  
/* obecn zpis */
int bitmap_write(const BITMAP *bmp, FILE *f, int type) {
  /* kontrola */
  if (type < 0 || type >= BITMAP_WRITE_METHODS_COUNT)
    return BW_INVALID_METHOD_ID;
  return bitmap_write_methods[type].method(bmp, f);
}

/* tohle mi vad */
static inline int ____x_stdc99_lacks_bsd_strcasecmp(const char *a, const char *b) {
  char c, d;
  for (; *a != '\0' && *b != '\0'; a++, b++) {
    c = tolower(*a);
    d = tolower(*b);
    if (c != d) return c > d ? 1 : -1;
  }
  return *a != '\0' ? 1 : *b != '\0' ? -1 : 0;
}

/* hled odpovdajc metodu */
int bitmap_write_match_type(const char *type) {
  struct bitmap_write_methods *bwm_p;
  /* kontrola */
  if (type == NULL) return -1;
  /* najdme odpovdajc metodu */
  for (bwm_p = bitmap_write_methods; bwm_p->method != NULL; bwm_p++)
    if (!____x_stdc99_lacks_bsd_strcasecmp(bwm_p->id, type))
      return bwm_p->type;
  /* tak nic... */
  return -1;
}
