#include <stdio.h> /* kvli size_t, u jpeg se na to vykalali */
#include <jpeglib.h>

#include "bitmap_write.h"

/* zpis do JPEG pomoc libjpeg */
int bitmap_write_jpeg(const BITMAP *bmp, FILE *f) {
  int state = BW_OK;
  /* mal kontrola */
  if (bmp == NULL)
    return BW_BAD_BITMAP;
  if (f == NULL)
    return BW_BAD_FILE;
  if (bmp->bits != 24)
    return BW_UNSUPPORTED_FORMAT; /* zatm jenom tenhle formt */
  {
    /* pomocn struktury */
    struct jpeg_compress_struct jpeg_c;
    struct jpeg_error_mgr jpeg_err;

    /* kontrola chyb obyejn */
    jpeg_c.err = jpeg_std_error(&jpeg_err);
    /* pprava pomocn struktury pro kompresi */
    jpeg_create_compress(&jpeg_c);
    jpeg_stdio_dest(&jpeg_c, f);
    /* rozmry obrzku */
    jpeg_c.image_width = bmp->width;
    jpeg_c.image_height = bmp->height;
    jpeg_c.input_components = 3; /* RGB - 3 sloky */
    jpeg_c.in_color_space = JCS_RGB; /* poad R,G,B */
    jpeg_set_defaults(&jpeg_c);
    /* zahajme kompresi */
    jpeg_start_compress(&jpeg_c, TRUE);
    /* Cykly jsou na nic - nsleduj pole! */
    jpeg_write_scanlines(&jpeg_c, (void *) bmp->lines, bmp->height);
    /* ukoneme kompresi */
    jpeg_finish_compress(&jpeg_c);
    /* a uklim pamt */
    jpeg_destroy_compress(&jpeg_c);
  }  
  return state; /* konec! */
}
