#include <png.h>

#include "bitmap_write.h"

/* zpis do PNG pomoc libpng */
int bitmap_write_png(const BITMAP *bmp, FILE *f) {
  int state = BW_OK;
  /* mal kontrola */
  if (bmp == NULL)
    return BW_BAD_BITMAP;
  if (f == NULL)
    return BW_BAD_FILE;
  if (bmp->bits != 24) /* zatm sta tenhle formt */
    return BW_UNSUPPORTED_FORMAT;
  {
    /* pipravme zpis PNGka */
    png_structp png_ptr = png_create_write_struct(
      PNG_LIBPNG_VER_STRING, (png_voidp) NULL, NULL, NULL);
    png_infop info_ptr = NULL;
    if (png_ptr != NULL) {
      /* jaksi pomocn struktura? ... */
      info_ptr = png_create_info_struct(png_ptr);
      if (info_ptr != NULL) {
        /* PNG bude zapisovat do ji otevenho souboru */
        png_init_io(png_ptr, f);
        /* nastaven komprese */
        png_set_compression_level(png_ptr, Z_BEST_COMPRESSION);
        /* nastaven formtu - zatm prost jen RGB 24-bitovej :( */
        png_set_IHDR(png_ptr, info_ptr, bmp->width, bmp->height, 8,
          PNG_COLOR_TYPE_RGB | PNG_COLOR_MASK_COLOR, PNG_INTERLACE_NONE,
          PNG_COMPRESSION_TYPE_DEFAULT, PNG_FILTER_TYPE_DEFAULT);
/*
#if __BYTE_ORDER == __BIG_ENDIAN
        png_set_bgr(png_ptr);
#endif
*/
        /* ukldn */
        png_write_info(png_ptr, info_ptr);
        /* aspo e se nen poteba namhat se psanm cyklu :-) */  
        png_write_image(png_ptr, (png_bytepp) bmp->lines);
        /* Konec? Jet ne pln... */
        png_write_end(png_ptr, info_ptr);
      } else state = BW_AUX_STRUCT_ERROR;
    } else state = BW_AUX_STRUCT_ERROR;
    /* klid */
    png_destroy_write_struct(&png_ptr, &info_ptr);
  }
  return state; /* konec! */
}
