#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/select.h>
#include <arpa/inet.h>
#ifndef POOL
#define POOL 10
#endif
int pipes[POOL][2]; /* roury, 0 = nic */
pid_t pids[POOL]; /* podprocesy, 0 = nic */
int main(int argc, char **argv) {
  int i, j, status = 0;
  struct in_addr ipv4a;
  char ipv4as[INET_ADDRSTRLEN], line[100], *p;
  struct hostent *he = NULL;
  fd_set fds;
  for (i = 0; i < POOL; i++) pipes[i][0] = pipes[i][1] = pids[i] = 0;
  for (i = 0; i < POOL; i++) { /* tvorba podproces */
    if (pipe(pipes[i]) < 0) { perror("Chyba roury"); break; }
    if ((pids[i] = fork()) < 0) { perror("Chyba vtven"); break; }
    if (pids[i] == 0) { /* podproces */
      close(pipes[i][1]); /* podproces bude jen st */
      while ((j = read(pipes[i][0], &ipv4a, sizeof(ipv4a))) > 0) {
	if (inet_ntop(AF_INET, &ipv4a, ipv4as, sizeof(ipv4as)) == NULL)
	  printf("Byla pedna chybn adresa.\n");
	else
          if ((he = gethostbyaddr(&ipv4a, sizeof(ipv4a), AF_INET)) != NULL)
	    printf("%s -> %s\n", ipv4as, he->h_name);
	  else
            printf("Nezjitn zznam pro %s (#%d - %s)\n", ipv4as, h_errno,
	      h_errno == HOST_NOT_FOUND ? "pota nenalezen" :
	      h_errno == NO_RECOVERY    ? "chyba DNS serveru" :
              h_errno == TRY_AGAIN      ? "zopakovat poadavek" : "chyba");
      }
      if (j < 0)
	printf("Chyba v %d. procesu: %s\n", i+1, strerror(errno)); 
      close(pipes[i][0]); /* u bylo doteno */
      exit(j == 0 ? 0 : 1);
    } else
      close(pipes[i][0]); /* hlavn proces bude jen zapisovat */
  }
  if (i < POOL) status |= 1;
  else
    while (!feof(stdin)) { /* natn adres */
      line[0] = '\0'; /* itn dku */
      if (fgets(line, sizeof(line), stdin) == NULL) /* kontrola chyb */
        if (!feof(stdin)) { /* ped koncem souboru je to opravdu chyba */
          perror("Chyba ten");
          status |= 2;
          break;
        }
      if ((p = strrchr(line, '\n')) != NULL) *p = '\0'; /* vyhodme '\n' */
      if (line[0] == '\0') continue; /* peskome przdn dky */
      if (inet_pton(AF_INET, line, &ipv4a) <= 0) { /* neplatn adresa */
	printf("Adresa '%s' je neplatn.\n", line);
	status |= 4;
      } else { /* poleme poadavek podprocesu */
	inet_ntop(AF_INET, &ipv4a, ipv4as, sizeof(ipv4as));
	FD_ZERO(&fds); /* vyrobme nov seznam rour pro vstup */
	j = 0; 
	for (i = 0; i < POOL; i++) {
	  FD_SET(pipes[i][1], &fds);
          if (j < pipes[i][1]) j = pipes[i][1]; /* select chce max. hodnotu */
	}
        select(j+1, NULL, &fds, NULL, NULL); /* najdeme volnou rouru */
	for (i = 0; i < POOL; i++)
          if (FD_ISSET(pipes[i][1], &fds)) {
            write(pipes[i][1], &ipv4a, sizeof(ipv4a)); /* poleme poadavek */
	    break;
	  }
      }
    }
  for (i = 0; i < POOL; i++) if (pipes[i][1] != 0) close(pipes[i][1]);
  printf("ek se na ukonen podproces.\n");
  for (i = 0; i < POOL; i++) 
    if (pids[i] > 0) {
      waitpid(pids[i], &j, 0); /* pokme na ukonen */
      if (WEXITSTATUS(j) != 0) {
        status |= 8;
        printf("Dolo k chyb v %d. podprocesu.\n", i+1);
      }
    }
  return status;
}
