// chat.h

#ifndef __chat_h
#define __chat_h

#include <curses.h>
#include <sys/types.h>
#include <arpa/inet.h>

enum mode { CLIENT=0, SERVER };

enum status { NOERR=0, NOARGS, BADARGS, NOMEM, CURSESFAILED };

enum error_code { ERR_OK=0, ERR_SOCKET, ERR_SOCKOPT, ERR_BIND, ERR_LISTEN,
  ERR_NOMEM, ERR_CONNECT, ERR_LOGIN };

struct setup {
  int port;
  enum mode mode;
  struct in_addr addr;
  char *nick;
};

// speciln kdy
#define SPEC_CODE_LEN 2
enum special_code_type { LOGIN_CODE=0, LOGOUT_CODE };
extern const char special_codes[][SPEC_CODE_LEN];

#define MAX_PACKET_SIZE 4096

// spust server
int chat_server(const struct setup *setup);

// spust klienta
int chat_client(const struct setup *setup, WINDOW *wmsg, WINDOW *winput);

#endif // __chat_h
