#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <netdb.h>
#include <sys/timeb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/poll.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>

#include "chat.h"
#include "protocol.h"

// spust klienta
int chat_client(const struct setup *setup, WINDOW *wmsg, WINDOW *winput) {
  int cs; // vytvoen zsuvky
  struct sockaddr_in sockaddr;
  if ((cs = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
    return ERR_SOCKET;

  memset(&sockaddr, 0, sizeof(struct sockaddr_in)); // oh shit!
  sockaddr.sin_family = AF_INET;
  sockaddr.sin_port = htons(setup->port);
  sockaddr.sin_addr = setup->addr;
  
  if (connect(cs, (struct sockaddr *) &sockaddr,
    sizeof(struct sockaddr_in)) < 0)
    return ERR_CONNECT;

  struct chat_packet inpacket, outpacket;
  int status;

  if (createpacket(&inpacket, MAX_PACKET_SIZE) < 0) {
    close(cs);
    return ERR_NOMEM;
  }
  
  wattrset(wmsg, COLOR_PAIR(COLOR_WHITE | A_BOLD));
  wprintw(wmsg, "Pihlaovn: ");
  wrefresh(wmsg);
  // tak se to pipojilo, odeleme sv jmno
  wrappacket(&outpacket, strlen(setup->nick), setup->nick);
  while ((status = send_packet(cs, &outpacket)) == 0);
  if (status < 0) {
    close(cs);
    return ERR_LOGIN;
  }
  wattrset(wmsg, COLOR_PAIR(COLOR_GREEN | A_BOLD));
  wprintw(wmsg, "hotovo.\n");
  wrefresh(wmsg);
  wattrset(wmsg, COLOR_PAIR(COLOR_WHITE));
  
  char text[MAX_PACKET_SIZE];
  int textp = 0;

  // na std. vstupu chceme hldat ten, na zsuvce taky
  struct pollfd ufds[] = { { .fd = 0, .events = POLLIN },
    { .fd = cs, .events = POLLIN } };
 
  int stop = 0, infullpacket = 0, i;
  int ch;
  int nfd = 2;

  while (!stop) {
    poll(ufds, nfd, -1); // pokme si na udlost
    if (ufds[0].revents & POLLIN) { // klvesnice
      ch = wgetch(winput);
      if (nfd == 1) { if (ch == KEY_F(10)) stop = 1; } else {
        switch (ch) {
          case KEY_F(5):
          case '\n':
          case KEY_ENTER:
  //          wprintw(wmsg, "Trasmitting: ");
            wrefresh(wmsg);
            wrappacket(&outpacket, textp, text);
            while (send_packet(cs, &outpacket) == 0);
  //          wprintw(wmsg, "done.\n");
            wrefresh(wmsg);
            textp = 0;
            break;
          case KEY_F(10):
            stop = 1;
            break;
          case KEY_BACKSPACE:
            if (textp > 0) textp--;
            break;
          default:
            if (textp < MAX_PACKET_SIZE)
              text[textp++] = ch;
            break;
        }
        wclear(winput);
        wmove(winput, 0, 0);
        wattrset(winput, COLOR_PAIR(COLOR_WHITE));
        i = textp - (COLS - 2);
        for (i < 0 ? i = 0 : 0; i < textp; i++)
          wprintw(winput, "%c", text[i]);
        wrefresh(winput);
      }
    }
    if (ufds[1].revents & POLLIN) { // pila zprva (aspo kus)
      infullpacket = recv_packet(cs, &inpacket);
      if (infullpacket < 0 && errno == EPIPE) {
        wattrset(wmsg, COLOR_PAIR(COLOR_RED | A_BOLD));
        wprintw(wmsg, "Server byl odpojen.\n");
        wrefresh(wmsg);
        nfd--; // sov vci u zjiovat nebudeme
        ufds[1].revents = 0; // smzneme stav
        infullpacket = 0;
      }
    }
    if (infullpacket) { // je u zprva cel?
      infullpacket = 0;
      if (((char *) inpacket.data)[0] == 0) { // speciln zprva
        wattrset(wmsg, COLOR_PAIR(COLOR_YELLOW | A_BOLD));
        wprintw(wmsg, "Zprva serveru");
        wattrset(wmsg, COLOR_PAIR(COLOR_BLUE | A_BOLD));
        waddch(wmsg, ':');
        switch (((char *) inpacket.data)[1]) {
          case LOGIN_CODE:
            wattrset(wmsg, COLOR_PAIR(COLOR_GREEN | A_BOLD));
            wprintw(wmsg, " vstoupil uivatel ");
            break;
          case LOGOUT_CODE:
            wattrset(wmsg, COLOR_PAIR(COLOR_RED | A_BOLD));
            wprintw(wmsg, " prv se odhlsil uivatel ");
            break;
          default:
            wattrset(wmsg, COLOR_PAIR(COLOR_MAGENTA));
            wprintw(wmsg, " neznm innost uivatele ");
            break;
        }
        i = SPEC_CODE_LEN + 1;
      } else {
        wattrset(wmsg, COLOR_PAIR(COLOR_GREEN | A_BOLD));
        for (i = 0; ((char *) inpacket.data)[i] != '\0'; i++)
          wprintw(wmsg, "%c", ((char *) inpacket.data)[i]);
        wattrset(wmsg, COLOR_PAIR(COLOR_BLUE | A_BOLD));
        waddch(wmsg, ':');
        wattrset(wmsg, COLOR_PAIR(COLOR_WHITE | A_BOLD));
        waddch(wmsg, ' ');
        i++;
      }
      for (; i < inpacket.length; i++)
        wprintw(wmsg, "%c", ((char *) inpacket.data)[i]);
      waddch(wmsg, '\n');
      wrefresh(wmsg);
      clearpacket(&inpacket);
    }
  }
 
  close(cs);
  
  return 0;
}
