// penosov protokol

#ifndef __protocol_h
#define __protocol_h

struct chat_packet {
  unsigned long int length, size;
  unsigned long int next;
  void *data;
};

// praktitj funkce pro posln dat
ssize_t write_all(int fd, void *data, size_t length);

// peruovateln odesla paket
int send_packet(int fd, struct chat_packet * cp);

// peruovateln pijma paket
int recv_packet(int fd, struct chat_packet * cp);

// vytvoen paketu
int createpacket(struct chat_packet *cp, int size);

// odstrann paketu
void freepacket(struct chat_packet *cp);

// zabalen dat do paketu
void wrappacket(struct chat_packet *cp, unsigned long int length, void *data);

enum packetstate { P_VOID = 0, P_EMPTY, P_BUSY, P_FINISHED };

// stav paketu
int packetstate(const struct chat_packet *cp);

// vyiten paketu
void clearpacket(struct chat_packet *cp);

#endif
